#include "stdafx.h"
#include "mfc.h"
#include <GL/gl.h>
#include <GL/glu.h>
#include <math.h>
#ifndef _CANVAS
#include "canvas.hpp"
#endif

void Canvas::box(GLfloat w,GLfloat h,GLfloat d)
{
	glBegin(GL_POLYGON);
		glNormal3f(0.0f,0.0f,1.0f);
		glTexCoord2f(0.0f, 1.0f);
		glVertex3f(1.0f*w,	1.0f*h,	1.0f*d);
		glTexCoord2f(0.0f, 0.0f);
		glVertex3f(-1.0f*w,	1.0f*h,	1.0f*d);
		glTexCoord2f(1.0f, 0.0f);
		glVertex3f(-1.0f*w,	-1.0f*h,	1.0f*d);
		glTexCoord2f(1.0f, 1.0f);
		glVertex3f(1.0f*w,	-1.0f*h,	1.0f*d);
	glEnd();

	glBegin(GL_POLYGON);
		glNormal3f(0.0f,0.0f,-1.0f);
		glTexCoord2f(0.0f, 1.0f);
		glVertex3f(1.0f*w,	1.0f*h,	-1.0f*d);
		glTexCoord2f(0.0f, 0.0f);
		glVertex3f(1.0f*w,	-1.0f*h,	-1.0f*d);
		glTexCoord2f(1.0f, 0.0f);
		glVertex3f(-1.0f*w,	-1.0f*h,	-1.0f*d);
		glTexCoord2f(1.0f, 1.0f);
		glVertex3f(-1.0f*w,	1.0f*h,	-1.0f*d);
	glEnd();

	glBegin(GL_POLYGON);
		glNormal3f(-1.0f,0.0f,0.0f);
		glTexCoord2f(0.0f, 1.0f);
		glVertex3f(-1.0f*w,	1.0f*h,	1.0f*d);
		glTexCoord2f(0.0f, 0.0f);
		glVertex3f(-1.0f*w,	1.0f*h,	-1.0f*d);
		glTexCoord2f(1.0f, 0.0f);
		glVertex3f(-1.0f*w,	-1.0f*h,	-1.0f*d);
		glTexCoord2f(1.0f, 1.0f);
		glVertex3f(-1.0f*w,	-1.0f*h,	1.0f*d);
	glEnd();

	glBegin(GL_POLYGON);
		glNormal3f(1.0f,0.0f,0.0f);
		glTexCoord2f(0.0f, 1.0f);
		glVertex3f(1.0f*w,	1.0f*h,	1.0f*d);
		glTexCoord2f(0.0f, 0.0f);
		glVertex3f(1.0f*w,	-1.0f*h,	1.0f*d);
		glTexCoord2f(1.0f, 0.0f);
		glVertex3f(1.0f*w,	-1.0f*h,	-1.0f*d);
		glTexCoord2f(1.0f, 1.0f);
		glVertex3f(1.0f*w,	1.0f*h,	-1.0f*d);
	glEnd();

	glBegin(GL_POLYGON);
		glNormal3f(0.0f,1.0f,0.0f);
		glTexCoord2f(0.0f, 1.0f);
		glVertex3f(-1.0f*w,	1.0f*h,	-1.0f*d);
		glTexCoord2f(0.0f, 0.0f);
		glVertex3f(-1.0f*w,	1.0f*h,	1.0f*d);
		glTexCoord2f(1.0f, 0.0f);
		glVertex3f(1.0f*w,	1.0f*h,	1.0f*d);
		glTexCoord2f(1.0f, 1.0f);
		glVertex3f(1.0f*w,	1.0f*h,	-1.0f*d);
	glEnd();

	glBegin(GL_POLYGON);
		glNormal3f(0.0f,-1.0f,0.0f);
		glTexCoord2f(0.0f, 1.0f);
		glVertex3f(-1.0f*w,	-1.0f*h,	-1.0f*d);
		glTexCoord2f(0.0f, 0.0f);
		glVertex3f(1.0f*w,	-1.0f*h,	-1.0f*d);
		glTexCoord2f(1.0f, 0.0f);
		glVertex3f(1.0f*w,	-1.0f*h,	1.0f*d);
		glTexCoord2f(1.0f, 1.0f);
		glVertex3f(-1.0f*w,	-1.0f*h,	1.0f*d);
	glEnd();

}
void Canvas::setLighting()
{
  GLfloat light0pos[]=     {0.7071f, 10.0f, 50.0f, 1.0f};
  GLfloat light0ambient[]= {0.3f, 0.3f, 0.3f, 1.0f};
  GLfloat light0diffuse[]= {0.6f, 0.6f, 0.6f, 1.0f};
  GLfloat light0specular[]={0.8f, 0.8f, 0.8f, 1.0f};
  GLfloat lmodel_ambient[]= {0.2f,0.2f,0.2f,1.0f};

  glLightModelfv(GL_LIGHT_MODEL_AMBIENT,lmodel_ambient);

  //glDisable(GL_DITHER);
  glShadeModel(GL_SMOOTH);
  
  glLightfv(GL_LIGHT0, GL_POSITION, light0pos);
  glLightfv(GL_LIGHT0, GL_AMBIENT, light0ambient);
  glLightfv(GL_LIGHT0, GL_DIFFUSE, light0diffuse);
  glLightfv(GL_LIGHT0, GL_SPECULAR, light0specular);
  
  glEnable(GL_LIGHTING);
  glEnable(GL_LIGHT0);
}
void Canvas::setDiffuseMaterialColor(GLfloat red, GLfloat green, GLfloat blue,GLfloat alpha)
{
	GLfloat diff[4];
	diff[0]=red;
	diff[1]=green;
	diff[2]=blue;
	diff[3]=alpha;
	glMaterialfv(GL_FRONT, GL_DIFFUSE,diff); 

}
void Canvas::setAmbientMaterialColor(GLfloat red, GLfloat green, GLfloat blue,GLfloat alpha)
{
	GLfloat amb[4];
	amb[0]=red;
	amb[1]=green;
	amb[2]=blue;
	amb[3]=alpha;
	glMaterialfv(GL_FRONT, GL_AMBIENT,amb); 

}
void Canvas::setSpecularMaterialColor(GLfloat red, GLfloat green, GLfloat blue,GLfloat alpha)
{
	GLfloat spec[4];
	spec[0]=red;
	spec[1]=green;
	spec[2]=blue;
	spec[3]=alpha;
	glMaterialfv(GL_FRONT, GL_SPECULAR,spec); 

}
void Canvas::setMaterialShininess(GLfloat shininess)
{
	glMateriali(GL_FRONT, GL_SHININESS, (GLint) shininess);
}
void Canvas::brassMaterial()
{
	  setAmbientMaterialColor(0.329412f,0.223529f,0.027451f,1.0f);
	  setDiffuseMaterialColor(0.780392f,0.568627f,0.113725f,1.0f);
	  setSpecularMaterialColor(0.992157f,0.941176f,0.807843f,1.0f);
      setMaterialShininess(27.8974f);
}
void Canvas::pewterMaterial()
{
	setAmbientMaterialColor(0.10588f,0.058824f,0.113725f,1.0f);
	setDiffuseMaterialColor(0.427451f,0.470588f,0.541176f,1.0f);
	setSpecularMaterialColor(0.3333f,0.3333f,0.521569f,1.0f);
	setMaterialShininess(9.84615f);
}
void Canvas::blackPlasticMaterial()
{
	setAmbientMaterialColor(0.0f,0.0f,0.0f,1.0f);
	setDiffuseMaterialColor(0.01f,0.01f,0.01f,1.0f);
	setSpecularMaterialColor(0.50f,0.50f,0.50f,1.0f);
	//setMaterialShininess(32);
	setMaterialShininess(64.0f);
}
void Canvas::goldMaterial()
{
	setAmbientMaterialColor(0.24725f,0.1995f,0.0745f,1.0f);
	setDiffuseMaterialColor(0.75164f,0.60648f,0.22648f,1.0f);
	setSpecularMaterialColor(0.628281f,0.555802f,0.366065f,1.0f);
	setMaterialShininess(100.0f);
}
void Canvas::bronzeMaterial()
{
	setAmbientMaterialColor(0.2125f,0.1275f,0.054f,1.0f);
	setDiffuseMaterialColor(0.714f,0.4284f,0.18144f,1.0f);
	setSpecularMaterialColor(0.393548f,0.271906f,0.166721f,1.0f);
	setMaterialShininess(25.6f);
}
void Canvas::chromeMaterial()
{
	setAmbientMaterialColor(0.25f,0.25f,0.25f,1.0f);
	setDiffuseMaterialColor(0.4f,0.4f,0.4f,1.0f);
	setSpecularMaterialColor(0.774597f,0.774597f,0.774597f,1.0f);
	setMaterialShininess(76.8f);
}
void Canvas::copperMaterial()
{
	setAmbientMaterialColor(0.19125f,0.0735f,0.0225f,1.0f);
	setDiffuseMaterialColor(0.7038f,0.27048f,0.0828f,1.0f);
	setSpecularMaterialColor(0.256777f,0.137622f,0.086014f,1.0f);
	setMaterialShininess(12.8f);
}
void Canvas::silverMaterial()
{
	setAmbientMaterialColor(0.19125f,0.19225f,0.19225f,1.0f);
	setDiffuseMaterialColor(0.50754f,0.50754f,0.50754f,1.0f);
	setSpecularMaterialColor(0.508273f,0.508273f,0.508273f,1.0f);
	setMaterialShininess(51.2f);
}
void Canvas::sphere(GLfloat radius)
{
	GLUquadricObj *obj = gluNewQuadric();
	gluQuadricDrawStyle(obj,GLU_FILL);
	gluQuadricNormals(obj,GLU_SMOOTH);
	gluQuadricOrientation(obj,GLU_OUTSIDE);
	gluQuadricTexture(obj, GL_TRUE);

	gluSphere(obj, radius, 20, 20);
	gluDeleteQuadric(obj);
}
void Canvas::errorHandler(char *module)
{
	GLenum errCode;
	const GLubyte *errString;

	if ((errCode = glGetError()) != GL_NO_ERROR)
	{
			errString=gluErrorString(errCode);
			printf("Opengl Error: %s Module %s\n",errString,module);
	}

}
void Canvas::saveBitmap(char *filename)
{
    BITMAPFILEHEADER header;       /* File header */
	BITMAPINFO	*info;
	long width,size,bitsize,infosize;
	GLubyte *bits;
	int viewport[4];
	FILE *fp;

	glGetIntegerv(GL_VIEWPORT,viewport);

	if((info = (BITMAPINFO *)malloc(sizeof(BITMAPINFOHEADER))) == NULL)
	{
			return;
	}

	width=viewport[2]*3;
	width=(width+3) & -3; /*Align to 4 bytes*/
	bitsize=width*viewport[3];

	if ((bits=(GLubyte *) malloc(bitsize))==NULL)
	{
		free(info);
	}
	glPixelStorei(GL_PACK_ALIGNMENT,4);
	glPixelStorei(GL_PACK_ROW_LENGTH,0);
	glPixelStorei(GL_PACK_SKIP_ROWS,0);
	glPixelStorei(GL_PACK_SKIP_PIXELS,0);

	glReadPixels(0,0,viewport[2],viewport[3],GL_BGR_EXT, GL_UNSIGNED_BYTE,bits);

	info->bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
	info->bmiHeader.biWidth=viewport[2];
	info->bmiHeader.biHeight=viewport[3];
	info->bmiHeader.biPlanes=1;
	info->bmiHeader.biBitCount=24;
	info->bmiHeader.biCompression=BI_RGB;
	info->bmiHeader.biSizeImage=bitsize;
	info->bmiHeader.biXPelsPerMeter=2952;
	info->bmiHeader.biYPelsPerMeter=2952;
	info->bmiHeader.biClrUsed=0;
	info->bmiHeader.biClrImportant=0;

	if(info->bmiHeader.biSizeImage==0)
	{
		bitsize=(info->bmiHeader.biWidth *
			info->bmiHeader.biBitCount+7)/8 *
			abs(info->bmiHeader.biHeight);
	}
	else
	{
		bitsize=info->bmiHeader.biSizeImage;
	}

	infosize=sizeof(BITMAPINFOHEADER);
	size=sizeof(BITMAPINFOHEADER)+infosize+bitsize;

	header.bfType='MB';
	header.bfSize=size;
	header.bfReserved1=0;
	header.bfReserved2=0;
	header.bfOffBits=sizeof(BITMAPFILEHEADER)+infosize;

	if((fp=fopen(filename,"wb"))==NULL)
	{
		return;
	}
	if (fwrite(&header,1,sizeof(BITMAPFILEHEADER),fp) < sizeof(BITMAPFILEHEADER))
	{
		fclose(fp);
		return;
	}
	if(fwrite(info,1,infosize,fp)<infosize)
	{
		fclose(fp);
		return;
	}
	if (fwrite(bits,1,bitsize,fp)<bitsize)
	{
		fclose(fp);
		return;
	}
	fclose(fp);
}

GLubyte* Canvas::loadDIBitmap(const char *filename, /* I - File to load */
             BITMAPINFO **info)    /* O - Bitmap information */
    {
    FILE             *fp;          /* Open file pointer */
    GLubyte          *bits;        /* Bitmap pixel bits */
    int              bitsize;      /* Size of bitmap */
    int              infosize;     /* Size of header information */
    BITMAPFILEHEADER header;       /* File header */


    /* Try opening the file; use "rb" mode to read this *binary* file. */
    if ((fp = fopen(filename, "rb")) == NULL)
        return (NULL);

    /* Read the file header and any following bitmap information... */
    if (fread(&header, sizeof(BITMAPFILEHEADER), 1, fp) < 1)
        {
        /* Couldn't read the file header - return NULL... */
	fclose(fp);
        return (NULL);
        }

    if (header.bfType != 'MB')	/* Check for BM reversed... */
        {
        /* Not a bitmap file - return NULL... */
        fclose(fp);
        return (NULL);
        }

    infosize = header.bfOffBits - sizeof(BITMAPFILEHEADER);
    if ((*info = (BITMAPINFO *)malloc(infosize)) == NULL)
        {
        /* Couldn't allocate memory for bitmap info - return NULL... */
        fclose(fp);
        return (NULL);
        }

    if (fread(*info, 1, infosize, fp) < infosize)
        {
        /* Couldn't read the bitmap header - return NULL... */
        free(*info);
        fclose(fp);
        return (NULL);
        }

    /* Now that we have all the header info read in, allocate memory for *
     * the bitmap and read *it* in...                                    */
    if ((bitsize = (*info)->bmiHeader.biSizeImage) == 0)
        bitsize = ((*info)->bmiHeader.biWidth *
                   (*info)->bmiHeader.biBitCount + 7) / 8 *
  	           abs((*info)->bmiHeader.biHeight);

    if ((bits = (GLubyte *) malloc(bitsize)) == NULL)
        {
        /* Couldn't allocate memory - return NULL! */
        free(*info);
        fclose(fp);
        return (NULL);
        }

    if (fread(bits, 1, bitsize, fp) < bitsize)
        {
        /* Couldn't read bitmap - free memory and return NULL! */
        free(*info);
        free(bits);
        fclose(fp);
        return (NULL);
        }

    /* OK, everything went fine - return the allocated bitmap... */
    fclose(fp);
    return (bits);
}
GLuint Canvas::textureLoad(char      *filename, /* I - Bitmap file to load */
            GLboolean alpha,     /* I - Generate alpha for bitmap */
            GLenum    minfilter, /* I - Minification filter */
	    GLenum    magfilter, /* I - Magnification filter */
	    GLenum    wrap)      /* I - Repeat or clamp */
    {
    int         i;               /* Looping var */
    BITMAPINFO	*info;           /* Bitmap information */
    GLubyte	*bits;           /* Bitmap RGB pixels */
    GLubyte     *ptr;            /* Pointer into bit buffer */
    GLubyte     temp;            /* Swapping variable */
    GLenum      type;            /* Texture type */
    GLuint      texture;         /* Texture object */

    /* Try loading the bitmap file... */
    bits = loadDIBitmap(filename, &info);
    if (bits == NULL)
        return (0);

    /*
     * Convert the bitmap data from BGR to RGB. Since texture images
     * must be a power of two, and since we can figure that we won't
     * have a texture image as small as 2x2 pixels, we ignore any
     * alignment concerns...
     */

    for (i = info->bmiHeader.biWidth * info->bmiHeader.biHeight, ptr = bits;
         i > 0;
	 i --, ptr += 3)
        {
	/* Swap red and blue */
	temp   = ptr[0];
	ptr[0] = ptr[2];
	ptr[2] = temp;
	}

    /* Figure out the type of texture... */
    if (info->bmiHeader.biHeight == 1)
        type = GL_TEXTURE_1D;
    else
        type = GL_TEXTURE_2D;

    /* Create and bind a texture object */
    glGenTextures(1, &texture);
    glBindTexture(type, texture);

    /* Set texture parameters */
    glTexParameteri(type, GL_TEXTURE_MAG_FILTER, magfilter);
    glTexParameteri(type, GL_TEXTURE_MIN_FILTER, minfilter);
    glTexParameteri(type, GL_TEXTURE_WRAP_S, wrap);
    glTexParameteri(type, GL_TEXTURE_WRAP_T, wrap);
    glTexEnvi(type, GL_TEXTURE_ENV_MODE, GL_MODULATE);

    /*
     * Set texture image; if the minification filter uses mip-mapping
     * then use gluBuild2D/1DMipmaps() to load the texture...
     */

    if (minfilter == GL_LINEAR || minfilter == GL_NEAREST)
        glTexImage2D(type, 0, 3, info->bmiHeader.biWidth,
                     info->bmiHeader.biHeight, 0, GL_RGB,
                     GL_UNSIGNED_BYTE, bits);
    else if (type == GL_TEXTURE_1D)
        gluBuild1DMipmaps(type, 3, info->bmiHeader.biWidth,
                          GL_RGB, GL_UNSIGNED_BYTE, bits);
    else
        gluBuild2DMipmaps(type, 3, info->bmiHeader.biWidth,
                          info->bmiHeader.biHeight, GL_RGB,
                          GL_UNSIGNED_BYTE, bits);

    /* Free the bitmap and return... */
    free(info);
    free(bits);

    return (texture);
}
void Canvas::setTextureMapping()
{
  glEnable(GL_TEXTURE_2D);


}
void Canvas::setBackgroundColor(GLfloat red, GLfloat green, GLfloat blue)
{
	glClearColor(red,green,blue,1.0f);
}
void Canvas::setColor(GLfloat red, GLfloat green, GLfloat blue)
{
	glColor3f(red,green,blue);
}
void Canvas::setBlending()
{
	glEnable(GL_BLEND);
	/*GL_SRC_ALPHA = Source color multiplied by source alpha
	  GL_ONE_MINUS_SRC_ALPHA =  Destination color is multiplied by 1,1,1,1 - source color)
	*/
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);

}
void Canvas::forward(GLfloat dist, int isVisible)
{
	const float RadPerDeg=0.017453393f;
	float x=CP.x + dist * cos(RadPerDeg*m_CurrDegree);
	float y=CP.y + dist * sin(RadPerDeg*m_CurrDegree);
	if(isVisible)
	{
		lineTo(x,y);
	}
	else
	{
		moveTo(x,y);
	}
}
void Canvas::setTurn(GLint angle)
{
	m_CurrDegree=angle;
}
void Canvas::turn(GLint angle)
{
	m_CurrDegree=(m_CurrDegree-angle)%360;
}
void Canvas::moveTo(GLfloat x, GLfloat y)
{
	CP.x=x;
	CP.y=y;
}
void Canvas::lineRel(float dx, float dy)
{
	float x= CP.x+dx;
	float y= CP.y+dy;
	lineTo(x,y);
	CP.x=x;
	CP.y=y;
}
void Canvas::lineTo(GLfloat x, GLfloat y)
{
	glBegin(GL_LINES);
		glVertex2f(CP.x,CP.y);
		glVertex2f(x,y);
	glEnd();
	CP.x=x;
	CP.y=y;
	glFinish();
}
void Canvas::nGON(int n, GLfloat cx, GLfloat cy, GLfloat radius, GLfloat rotAngle)
{
	int k;
	GLdouble angle;
	GLdouble angleInc;

	if(n<3) return;
	angle= rotAngle * 3.14159265/180.0f;

	angleInc=2*3.14159265/n;
	moveTo((GLfloat)(radius*cos(angle)+cx),(GLfloat)(radius*sin(angle+cy)));
	for(k=0; k<n; k++)
	{
		angle+=angleInc;
		lineTo((GLfloat)(radius*cos(angle)+cx),(GLfloat)(radius*sin(angle)+cy));
	}

}
void Canvas::drawArch(Point center, float radius, float startAngle, float sweep)
{
	const int n=36;
	float angle,angleInc;
	float cx,cy;
	int k;

	angle=startAngle * 3.14159265f/180.0f;
	angleInc=sweep * 3.14159265f/(180.0f*n);
	cx=center.x, cy=center.y;
	moveTo(cx+radius*cos(angle), cy+radius*sin(angle));
	for(k=1; k<=(n+1); k++, angle += angleInc)
	{
		lineTo(cx+radius*cos(angle),cy+radius*sin(angle));
	}
}
void Canvas::reduceToUnit(GLfloat vector[3])
{
float length;
length = (float)sqrt((vector[0]*vector[0]) + 
(vector[1]*vector[1]) +
(vector[2]*vector[2]));
if(length == 0.0f)
	length = 1.0f;
	vector[0] /= length;
	vector[1] /= length;
	vector[2] /= length;
}
void Canvas::calcNormal(VECTOR_STRUCT_TYPE *vertex1, VECTOR_STRUCT_TYPE *vertex2,VECTOR_STRUCT_TYPE *vertex3,GLfloat out[3])
{
float v1[3],v2[3];
static const int x = 0;
static const int y = 1;
static const int z = 2;
v1[x] = vertex1->m_x - vertex2->m_x;
v1[y] = vertex1->m_y - vertex2->m_y;
v1[z] = vertex1->m_z - vertex2->m_z;
v2[x] = vertex2->m_x - vertex3->m_x;
v2[y] = vertex2->m_y - vertex3->m_y;
v2[z] = vertex2->m_z - vertex3->m_z;
/*Cross Product*/
out[x] = v1[y]*v2[z] - v1[z]*v2[y];
out[y] = v1[z]*v2[x] - v1[x]*v2[z];
out[z] = v1[x]*v2[y] - v1[y]*v2[x];
reduceToUnit(out);

}
void Canvas::calcNormal2(GLfloat v[3][3], GLfloat out[3])
{
float v1[3],v2[3];
static const int x = 0;
static const int y = 1;
static const int z = 2;
v1[x] = v[0][x] - v[1][x];
v1[y] = v[0][y] - v[1][y];
v1[z] = v[0][z] - v[1][z];
v2[x] = v[1][x] - v[2][x];
v2[y] = v[1][y] - v[2][y];
v2[z] = v[1][z] - v[2][z];
/*Cross Product*/
out[x] = v1[y]*v2[z] - v1[z]*v2[y];
out[y] = v1[z]*v2[x] - v1[x]*v2[z];
out[z] = v1[x]*v2[y] - v1[y]*v2[x];
reduceToUnit(out);
}
void Canvas::cone(GLfloat radius,GLfloat height)
{
GLUquadricObj *obj = gluNewQuadric();
gluQuadricDrawStyle(obj,GLU_FILL);
gluQuadricNormals(obj,GLU_SMOOTH);
gluQuadricOrientation(obj,GLU_OUTSIDE);
gluQuadricTexture(obj, GL_TRUE);

/*Base Cylinder*/
glPushMatrix();
	/* Rotate about the X axis */
	glRotatef(90.0f,1.0f,0.0f,0.0f);
	/* qobj = quadric object
	baseRadius
	topRadius
	height,
	slices (Subdivisions around the Z axis)
	stacks (Subdivisions around the Z axis)
	*/
	gluCylinder(obj,0,radius,height,20,10);
glPopMatrix(); 

/*Bottom*/
glPushMatrix(); 
	glTranslatef(0.0f,-height,0.0f);
	glRotatef(90.0f,1.0f,0.0f,0.0f);
	/* qobj = quadric object
	innerRadius = Inner radius of the disk
	outerRadius = Outer radius of the disk
	slices = number of subdivisions around the Z axis
	loops = number of concentric rings about the origin
	*/
	gluDisk(obj,0.0f,radius,20,20);
glPopMatrix();
gluDeleteQuadric(obj);
}
void Canvas::cylinder(GLfloat radius,GLfloat height)
{
GLUquadricObj *obj = gluNewQuadric();
gluQuadricDrawStyle(obj,GLU_FILL);
gluQuadricNormals(obj,GLU_SMOOTH);
gluQuadricOrientation(obj,GLU_OUTSIDE);
gluQuadricTexture(obj, GL_TRUE);

/*Base Cylinder*/
glPushMatrix();
	/* Rotate about the X axis */
	glRotatef(90.0f,1.0f,0.0f,0.0f);
	/* qobj = quadric object
	baseRadius
	topRadius
	height,
	slices (Subdivisions around the Z axis)
	stacks (Subdivisions around the Z axis)
	*/
	gluCylinder(obj,radius,radius,height,10,10);
glPopMatrix(); 
/* Lid*/
glPushMatrix(); 
	glRotatef(-90.0f,1.0f,0.0f,0.0f);
	/* qobj = quadric object
	innerRadius = Inner radius of the disk
	outerRadius = Outer radius of the disk
	slices = number of subdivisions around the Z axis
	loops = number of concentric rings about the origin
	*/
	gluDisk(obj,0.0f,radius,10,10);
glPopMatrix();
	/*Bottom*/
glPushMatrix(); 
	glTranslatef(0.0f,-height,0.0f);
	glRotatef(90.0f,1.0f,0.0f,0.0f);
	/* qobj = quadric object
	innerRadius = Inner radius of the disk
	outerRadius = Outer radius of the disk
	slices = number of subdivisions around the Z axis
	loops = number of concentric rings about the origin
	*/
	gluDisk(obj,0.0f,radius,10,10);
glPopMatrix();

gluDeleteQuadric(obj);
}
VECTOR_STRUCT_TYPE* Canvas::parameterizeSplineCurve(LATHE_CONTROL_POINT_STRUCT_TYPE *ctrl, GLfloat t)
{
VECTOR_STRUCT_TYPE *vector;
MATRIX4X4 Mcr;
MATRIX4X1 Mt;
MATRIX4X1 MPar;
MATRIX1X4 Px;
MATRIX1X4 Py;
MATRIX1X4 Pz;

	vector= (VECTOR_STRUCT_TYPE *) malloc (sizeof(VECTOR_STRUCT_TYPE));
	Mcr[0][0]= -0.5; Mcr[1][0]= 1.5; Mcr[2][0]= -1.5; Mcr[3][0]= 0.5;
	Mcr[0][1]= 1.0; Mcr[1][1]= -2.5; Mcr[2][1]= 2.0; Mcr[3][1]= -0.5;
	Mcr[0][2]= -0.5; Mcr[1][2]= 0.0; Mcr[2][2]= 0.5; Mcr[3][2]= 0.0;
	Mcr[0][3]= 0.0; Mcr[1][3]= 1.0; Mcr[2][3]= 0.0; Mcr[3][3]= 0.0;
	
	Px[0][0]=ctrl->Px[0];
	Px[0][1]=ctrl->Px[1];
	Px[0][2]=ctrl->Px[2];
	Px[0][3]=ctrl->Px[3];
	Py[0][0]=ctrl->Py[0];
	Py[0][1]=ctrl->Py[1];
	Py[0][2]=ctrl->Py[2];
	Py[0][3]=ctrl->Py[3];
	Pz[0][0]=ctrl->Pz[0];
	Pz[0][1]=ctrl->Pz[1];
	Pz[0][2]=ctrl->Pz[2];
	Pz[0][3]=ctrl->Pz[3];

	MPar[0][0]=t*t*t;
	MPar[0][1]=t*t;
	MPar[0][2]=t;
	MPar[0][3]=1;
	
	Matrix4X1_4X4(&Mt,&MPar,&Mcr); 
	vector->m_x = (GLfloat) Matrix4X1_1X4(&Mt,&Px); 
	vector->m_y = (GLfloat) Matrix4X1_1X4(&Mt,&Py); 
	vector->m_z = (GLfloat) Matrix4X1_1X4(&Mt,&Pz); 

	return (vector);
}
double Canvas::Matrix4X1_1X4(MATRIX4X1 *matrix1, MATRIX1X4 *matrix2)
{
register int k;
double result=0.0;
	for (k = 0 ; k < 4 ; k++)
		result += (*matrix1)[k][0] * (*matrix2)[0][k];
	return(result);
}
void Canvas::Matrix4X1_4X4(MATRIX4X1 *result, MATRIX4X1 *matrix1, MATRIX4X4 *matrix2)
{
register int i, k;
MATRIX4X1 temp_matrix;
	for (i = 0 ; i < 4 ; i++)
	{
	temp_matrix[i][0] = 0.0;
		for (k = 0 ; k < 4 ; k++)
		{
			temp_matrix[i][0] += (*matrix1)[k][0] * (*matrix2)[i][k];
		}
	}
	for (i = 0 ; i < 4 ; i++)
		(*result)[i][0] = temp_matrix[i][0];
}
void Canvas::Matrix1X4_4X4(MATRIX1X4 *result, MATRIX1X4 *matrix1, MATRIX4X4 *matrix2)
{
register int i, k;
MATRIX4X1 temp_matrix;
	for (i = 0 ; i < 4 ; i++)
	{
		temp_matrix[i][0] = 0.0;
			for (k = 0 ; k < 4 ; k++)
			{
				temp_matrix[i][0] += (*matrix1)[0][k] * (*matrix2)[i][k];
			}
	}
	for (i = 0 ; i < 4 ; i++)
		(*result)[0][i] = temp_matrix[i][0];
}

VECTOR_STRUCT_TYPE* Canvas::rotate(GLfloat angle,GLfloat ux,GLfloat uy,GLfloat uz, VECTOR_STRUCT_TYPE *vector)
{
MATRIX4X4 Mt;
MATRIX1X4 Mp;
MATRIX1X4 Mr;

float sinTheta;
float cosTheta;
VECTOR_STRUCT_TYPE *ret_vector;

ret_vector= (VECTOR_STRUCT_TYPE *) malloc (sizeof(VECTOR_STRUCT_TYPE));

sinTheta=(float)sin(angle/180.0f*3.142);
cosTheta=(float)cos(angle/180.0f*3.142);

Mt[0][0]= cosTheta+(1-cosTheta)*pow(ux,2);
Mt[0][1]= (1-cosTheta)*uy*ux-sinTheta*uz; 
Mt[0][2]= (1-cosTheta)*uz*ux+sinTheta*uy;
Mt[0][3]= 0.0f;  

Mt[1][0]= (1-cosTheta)*ux*uy+sinTheta*uz;
Mt[1][1]= cosTheta+(1-cosTheta)*pow(uy,2);
Mt[1][2]= (1-cosTheta)*uz*uy-sinTheta*ux;
Mt[1][3]= 0.0f; 

Mt[2][0]= (1-cosTheta)*ux*uz-sinTheta*uy;
Mt[2][1]= (1-cosTheta)*uy*uz+sinTheta*ux;
Mt[2][2]= cosTheta+(1-cosTheta)*pow(uz,2);
Mt[2][3]= 0.0f;

Mt[3][0]=0;
Mt[3][1]=0;
Mt[3][2]=0;
Mt[3][3]=1;

Mp[0][0]=vector->m_x;
Mp[0][1]=vector->m_y;
Mp[0][2]=vector->m_z;
Mp[0][3]=1;


Matrix1X4_4X4(&Mr,&Mp,&Mt); 

ret_vector->m_x=(float)Mr[0][0];
ret_vector->m_y=(float)Mr[0][1];
ret_vector->m_z=(float)Mr[0][2];
return(ret_vector);

}
GLint Canvas::reserveDisplayListId(char *name)
{
	int i;
	
	for(i=0;i<DISPLAY_LIST_SIZE; i++)
	{
		if(display_list[i].available==YES)
		{
			display_list[i].available=NO;
			strcpy(display_list[i].name,name);
			display_list[i].id=glGenLists(1);
			return(display_list[i].id);
		}
	}
	return(-1);
}
GLint Canvas::findDisplayListId(char *name)
{
	int i;
	
	for(i=0;i<DISPLAY_LIST_SIZE; i++)
	{
		if(strcmp(display_list[i].name,name)==0)
		{
			return(display_list[i].id);
		}
	}
	return(-1);
}

GLint Canvas::reserveTextureMap(char *name,char *filename)
{

	int i;
	
	for(i=0;i<TEXTURE_MAP_LIST_SIZE; i++)
	{
		if(texture_map_list[i].available==YES)
		{
			texture_map_list[i].available=NO;
			strcpy(texture_map_list[i].name,name);

			texture_map_list[i].id=textureLoad(filename, GL_FALSE, GL_NEAREST,
                                GL_NEAREST, GL_REPEAT);
			return(texture_map_list[i].id);
		}
	}
	return(-1);

}
GLint Canvas::findTextureMap(char *name)
{
	int i;
	
	for(i=0;i<TEXTURE_MAP_LIST_SIZE; i++)
	{
		if(strcmp(texture_map_list[i].name,name)==0)
		{
			return(texture_map_list[i].id);
		}
	}
	return(-1);
}

void Canvas::sinc(char *Name)
{
	float vertexes[4][3];
	float normal[4];
	GLint sinc_id;
	GLfloat x,z,y;
	GLfloat xt,zt;
	GLfloat square_size;

	sinc_id=reserveDisplayListId(Name);

	if(sinc_id==-1)
	{
		printf("\nNo more Display List ids available\n");
		return;
	}

	glNewList(sinc_id,GL_COMPILE);

	setAmbientMaterialColor(0.0f,0.0f,0.5f,1.0f);
	setDiffuseMaterialColor(0.0f,0.0f,0.8f,1.0f);
	
	square_size=0.5f;

	for(z=-20.0f; z<=20.0f; z+=square_size)
		for(x=-20.0f;x<=20.0f; x+=square_size)
	{

		/*Vertex 1*/
		xt=x;
		zt=z;
		if (xt==0 && zt==0)
		{
			y=0.0f;
		}
		else
		{
		y=(float)3.0f*sin(sqrt(xt*xt+zt*zt))/sqrt(xt*xt+zt*zt);
		}
		
		
		vertexes[0][0]=xt;
		vertexes[0][1]=y;
		vertexes[0][2]=zt;

		/*Vertex 2*/
	
		xt=x;
		zt=z+square_size;
		if (xt==0.0f && zt==0.0f)
		{
			y=0.0f;
		}
		else
		{
		y=(float)3.0f*sin(sqrt(xt*xt+zt*zt))/sqrt(xt*xt+zt*zt);
		}
		
		
		vertexes[1][0]=xt;
		vertexes[1][1]=y;
		vertexes[1][2]=zt;

		/*Vertex 3*/
	
		xt=x+square_size;
		zt=z+square_size;
		if (xt==0.0f && zt==0.0f)
		{
			y=0.0f;
		}
		else
		{
		y=(float)3.0f*sin(sqrt(xt*xt+zt*zt))/sqrt(xt*xt+zt*zt);
		}
		
		vertexes[2][0]=xt;
		vertexes[2][1]=y;
		vertexes[2][2]=zt;

		/*Vertex 4*/
		xt=x+square_size;
		zt=z;
		if (xt==0.0f && zt==0.0f)
		{
			y=0.0f;
		}
		else
		{
		y=(float)3.0f*sin(sqrt(xt*xt+zt*zt))/sqrt(xt*xt+zt*zt);
		}
		
		vertexes[3][0]=xt;
		vertexes[3][1]=y;
		vertexes[3][2]=zt;

		calcNormal2(vertexes,normal);
		glBegin(GL_POLYGON);
			glNormal3f(normal[0],normal[1],normal[2]);
			glVertex3f(vertexes[0][0],vertexes[0][1],vertexes[0][2]);
			glVertex3f(vertexes[1][0],vertexes[1][1],vertexes[1][2]);
			glVertex3f(vertexes[2][0],vertexes[2][1],vertexes[2][2]);
			glVertex3f(vertexes[3][0],vertexes[3][1],vertexes[3][2]);
		glEnd();


	}
	glEndList();

}
void Canvas::textureCylinder(GLfloat radius,GLfloat height)
{
	GLUquadricObj *obj = gluNewQuadric();

	gluQuadricDrawStyle(obj,GLU_FILL);
	gluQuadricNormals(obj,GLU_SMOOTH);
	gluQuadricOrientation(obj,GLU_OUTSIDE);
	gluQuadricTexture(obj, GL_TRUE);

	/*Base Cylinder*/
	glPushMatrix();
	/* Rotate about the X axis */
	glRotatef(90.0f,1.0f,0.0f,0.0f);
	/* qobj = quadric object
	baseRadius
	topRadius
	height,
	slices (Subdivisions around the Z axis)
	stacks (Subdivisions around the Z axis)
	*/
	gluCylinder(obj,radius,radius,height,10,10);
	glPopMatrix(); 
	/* Lid*/
	glPushMatrix(); 
	glTranslatef(0.0f,0.0f,0.0f);
	glRotatef(-90.0f,1.0f,0.0f,0.0f);
	/* qobj = quadric object
	innerRadius = Inner radius of the disk
	outerRadius = Outer radius of the disk
	slices = number of subdivisions around the Z axis
	loops = number of concentric rings about the origin
	*/
	gluDisk(obj,0.0f,radius,10,10);
	glPopMatrix();
	/*Bottom*/
	glPushMatrix(); 
	glTranslatef(0.0f,-height,0.0f);
	glRotatef(90.0f,1.0f,0.0f,0.0f);
	/* qobj = quadric object
	innerRadius = Inner radius of the disk
	outerRadius = Outer radius of the disk
	slices = number of subdivisions around the Z axis
	loops = number of concentric rings about the origin
	*/
	gluDisk(obj,0.0f,radius,10,10);
	glPopMatrix();
	gluDeleteQuadric(obj);
}
void Canvas::textureSphere(GLfloat radius)
{
	GLUquadricObj *obj = gluNewQuadric();

	gluQuadricDrawStyle(obj,GLU_FILL);
	gluQuadricNormals(obj,GLU_SMOOTH);
	gluQuadricTexture(obj, GL_TRUE);
	gluQuadricOrientation(obj,GLU_OUTSIDE);
	gluSphere(obj, radius, 10, 10);
	gluDeleteQuadric(obj);
}
void Canvas::toroidal_Spiral(char *Name)
{
	GLfloat t;
	GLfloat x,y,z;
	GLfloat a,b,c,p,q;
	GLfloat theta;
	GLint id;

	/*
	a=radius of the torus
	b=cross section radius of the torus
	p=number of interweavings
	q=number of twists
	c=constant
	*/
		a=5.0f;
		b=3.0f;
		p=1.0f;
		q=7.0f;
		c=3.0f;

	id=reserveDisplayListId(Name);

	glNewList(id,GL_COMPILE_AND_EXECUTE);

	glPushMatrix();
		glBegin(GL_LINE_STRIP);
		for(theta=0.0f; theta<=360.0f; theta+=1.0f)
		{
			t=(GLfloat)(theta/180.0*3.142f);
			x=(GLfloat)(a+b*cos(q*t))*cos(p*t);
			y=(GLfloat)(a+b*cos(q*t))*sin(p*t);
			z=(GLfloat)c*sin(q*t);
			glVertex3f(x,y,z);
		}
	glEnd();

	glPopMatrix();
	glEndList();

}
void Canvas::buildGrid(char *Name,int size)
{
int r,c;
int nStep = 200;
GLint iGrid_Id;


  glPushMatrix();

	iGrid_Id=reserveDisplayListId(Name);

	glNewList(iGrid_Id,GL_COMPILE_AND_EXECUTE);

	/* Just draw a bunch of horizontal and vertical lines */
	glBegin(GL_LINES);

	for(r = -size; r  <= size; r += nStep)
		{
		glVertex3f((float)r, 0.0f, (float)-size);
		glVertex3f((float)r, 0.0f, (float)size);
		}

	for(c = -size; c <= size; c += nStep)
		{
		glVertex3f((float)size, 0.0f, (float)c);
		glVertex3f((float)-size, 0.0f, (float)c);
		}

	glEnd();

	glEndList();

  glPopMatrix();
}

void Canvas::ellipsoid(char *Name)
{
	float vertexes[4][3];
	float normal[4];
	GLint id;
	GLfloat a, b, c;
	GLfloat square_size;
	GLfloat dphi, dtheta;
	GLfloat phi,theta;

	id=reserveDisplayListId(Name);

	if(id==-1)
	{
		printf("\nNo more Display List ids available\n");
		return;
	}

	glNewList(id,GL_COMPILE);


	//Length of sides of the polygons which make up the skin of the ellipsoid
	square_size = 0.4f;

//*********  These points determine the radius of the ellipsoid  ***************
	a = 1.8f; // a = ecentricity about the X-AXIS
	b = 0.8f; // b = ecentricity about the Y-AXIS
	c = 1.8f; // c = ecentricity about the Z-AXIS
//******************************************************************************




	//create ellipsoid
	for(phi = (GLfloat)(-PI/2.0f); phi <= (GLfloat)(PI/2.0f); phi += square_size)
		for(theta = 0.0f; theta <= 2.0f*PI; theta += square_size)
		{
			dphi = phi + square_size;
			dtheta = theta + square_size;

			//Vertex 1
			vertexes[0][0]=(GLfloat)a*cos(phi)*cos(theta); //x
			vertexes[0][1]=(GLfloat)b*sin(phi);  //y
			vertexes[0][2]=(GLfloat)c*cos(phi)*sin(theta); //z

			//Vertex 2	
			vertexes[1][0]=(GLfloat)a*cos(dphi)*cos(theta); //x
			vertexes[1][1]=(GLfloat)b*sin(dphi); //y
			vertexes[1][2]=(GLfloat)c*cos(dphi)*sin(theta); //z

			//Vertex 3*
			vertexes[2][0]=(GLfloat)a*cos(dphi)*cos(dtheta); //x
			vertexes[2][1]=(GLfloat)b*sin(dphi); //y
			vertexes[2][2]=(GLfloat)c*cos(dphi)*sin(dtheta); //z

			//Vertex 4
			vertexes[3][0]=(GLfloat)a*cos(phi)*cos(dtheta); //x
			vertexes[3][1]=(GLfloat)b*sin(phi); //y
			vertexes[3][2]=(GLfloat)c*cos(phi)*sin(dtheta); //z

			//draw the skin of ellipsoid using the defined rectagular region
			calcNormal2(vertexes,normal);
			glBegin(GL_POLYGON);
				glNormal3f(normal[0],normal[1],normal[2]);
				glVertex3f(vertexes[0][0],vertexes[0][1],vertexes[0][2]);
				glVertex3f(vertexes[1][0],vertexes[1][1],vertexes[1][2]);
				glVertex3f(vertexes[2][0],vertexes[2][1],vertexes[2][2]);
				glVertex3f(vertexes[3][0],vertexes[3][1],vertexes[3][2]);
			glEnd();
		}

	glEndList();

}
void Canvas::torus(char *Name)
{
	GLfloat vertexes[4][3];
	GLfloat normal[3];
	GLfloat x;
	GLfloat y;
	GLfloat z;
	GLfloat phi;
	GLfloat theta;
	GLfloat CosPhi;
	GLfloat SinPhi;
	GLfloat SinTheta;
	GLfloat CosTheta;
	GLfloat outerRadius;
	GLfloat innerRadius;
	GLint id;

	outerRadius=5.0f;
	innerRadius=3.0f;

	id=reserveDisplayListId(Name);

	if(id==-1)
	{
		printf("\nNo more Display List ids available\n");
		return;
	}

	glNewList(id,GL_COMPILE);

	for(phi=0.0f; phi <= 360.0f; phi+=20.0f)
	{
		for(theta=0.0f; theta<=360.0f; theta+=20.0f)
		{
		CosPhi=(GLfloat)cos(phi/180.0*3.142);
		SinPhi=(GLfloat)sin(phi/180.0*3.142);
		CosTheta=(GLfloat)cos(theta/180.0*3.142);
		SinTheta=(GLfloat)sin(theta/180.0*3.142);
		/*Vertex 1*/
		x= (GLfloat)CosTheta * (CosPhi * innerRadius+outerRadius);
		y= (GLfloat)SinTheta * (CosPhi * innerRadius+outerRadius);
		z= (GLfloat)(SinPhi) * innerRadius;
		vertexes[0][0]=x;
		vertexes[0][1]=y;
		vertexes[0][2]=z;
		/*Vertex 2*/
		CosPhi=(GLfloat)cos(phi/180.0f*3.142f);
		SinPhi=(GLfloat)sin(phi/180.0f*3.142f);
		CosTheta=(GLfloat)cos((theta+20)/180.0f*3.142f);
		SinTheta=(GLfloat)sin((theta+20)/180.0f*3.142f);
		x= (GLfloat)CosTheta * (CosPhi * innerRadius+outerRadius);
		y= (GLfloat)SinTheta * (CosPhi * innerRadius+outerRadius);
		z= (GLfloat)(SinPhi) * innerRadius;
		vertexes[1][0]=x;
		vertexes[1][1]=y;
		vertexes[1][2]=z;
		/*Vertex 3*/
		CosPhi=(GLfloat)cos((phi+20)/180.0*3.142);
		SinPhi=(GLfloat)sin((phi+20)/180.0*3.142);
		CosTheta=(GLfloat)cos((theta+20)/180.0*3.142);
		SinTheta=(GLfloat)sin((theta+20)/180.0*3.142);
		x= (GLfloat)CosTheta * (CosPhi * innerRadius+outerRadius);
		y= (GLfloat)SinTheta * (CosPhi * innerRadius+outerRadius);
		z= (GLfloat)(SinPhi) * innerRadius;
		vertexes[2][0]=x;
		vertexes[2][1]=y;
		vertexes[2][2]=z;
		/*Vertex 4*/
		CosPhi=(GLfloat)cos((phi+20)/180.0*3.142);
		SinPhi=(GLfloat)sin((phi+20)/180.0*3.142);
		CosTheta=(GLfloat)cos((theta)/180.0*3.142);
		SinTheta=(GLfloat)sin((theta)/180.0*3.142);
		x= (GLfloat)CosTheta * (CosPhi * innerRadius+outerRadius);
		y= (GLfloat)SinTheta * (CosPhi * innerRadius+outerRadius);
		z= (GLfloat)(SinPhi) * innerRadius;
		vertexes[3][0]=x;
		vertexes[3][1]=y;
		vertexes[3][2]=z;
		calcNormal2(vertexes,normal);
		glBegin(GL_POLYGON);
			glNormal3f(normal[0],normal[1],normal[2]);
			glVertex3f(vertexes[0][0],vertexes[0][1],vertexes[0][2]);
			glVertex3f(vertexes[1][0],vertexes[1][1],vertexes[1][2]);
			glVertex3f(vertexes[2][0],vertexes[2][1],vertexes[2][2]);
			glVertex3f(vertexes[3][0],vertexes[3][1],vertexes[3][2]);
		glEnd();
		}
	}
	glEndList();
}

void Canvas::helix(char *Name)
{
GLfloat x;
GLfloat y;
GLfloat z;
GLfloat phi;
GLfloat theta;
GLfloat v,u;
GLfloat r;
GLint id;
GLfloat vertexes[4][3];
GLfloat normal[3];
	
	r=2.0f;

	id=reserveDisplayListId(Name);

	if(id==-1)
	{
		printf("\nNo more Display List ids available\n");
		return;
	}

	glNewList(id,GL_COMPILE_AND_EXECUTE);

	for(phi=0.0f; phi <= 360.0f; phi+=20.0f)
	{
		for(theta=0.0f; theta<=360.0f*10.0f; theta+=20.0f)
		{
		v=(GLfloat)(phi/180.0f*3.142f);
		u=(GLfloat)(theta/180.0f*3.142f);
		/*Vertex 1*/

		x=(GLfloat)(cos(u)*(2.0f+cos(v) ))*r;
		y=(GLfloat)(sin(u)*(2.0f+cos(v) ))*r;				
		z=(GLfloat)((( u-(2.0f*3.142f)) + sin(v) ) * r);

		vertexes[0][0]=x;
		vertexes[0][1]=y;
		vertexes[0][2]=z;

		/*Vertex 2*/
		v=(GLfloat)(phi/180.0f*3.142f);
		u=(GLfloat)((theta+20.0f)/180.0f*3.142f);

		x=(GLfloat)(cos(u)*(2.0f+cos(v) ))*r;
		y=(GLfloat)(sin(u)*(2.0f+cos(v) ))*r;				
		z=(GLfloat)((( u-(2.0f*3.142f)) + sin(v) ) * r);

		vertexes[1][0]=x;
		vertexes[1][1]=y;
		vertexes[1][2]=z;

		/*Vertex 3*/
		v=(GLfloat)((phi+20.0f)/180.0f*3.142f);
		u=(GLfloat)((theta+20.0f)/180.0f*3.142f);

		x=(GLfloat)(cos(u)*(2.0f+cos(v) ))*r;
		y=(GLfloat)(sin(u)*(2.0f+cos(v) ))*r;				
		z=(GLfloat)((( u-(2.0f*3.142f)) + sin(v) ) * r);

		vertexes[2][0]=x;
		vertexes[2][1]=y;
		vertexes[2][2]=z;

		/*Vertex 4*/
		v=(GLfloat)((phi+20.0f)/180.0f*3.142f);
		u=(GLfloat)((theta)/180.0f*3.142f);

		x=(GLfloat)(cos(u)*(2.0f+cos(v) ))*r;
		y=(GLfloat)(sin(u)*(2.0f+cos(v) ))*r;				
		z=(GLfloat)((( u-(2.0f*3.142f)) + sin(v) ) * r);

		vertexes[3][0]=x;
		vertexes[3][1]=y;
		vertexes[3][2]=z;

		calcNormal2(vertexes,normal);
		glBegin(GL_POLYGON);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertexes[0][0],vertexes[0][1],vertexes[0][2]);
		glVertex3f(vertexes[1][0],vertexes[1][1],vertexes[1][2]);
		glVertex3f(vertexes[2][0],vertexes[2][1],vertexes[2][2]);
		glVertex3f(vertexes[3][0],vertexes[3][1],vertexes[3][2]);
		glEnd();
		}
	}
	glEndList();
}

void Canvas::polyhedra(char *Name)
{
	GLint poly_id;
	GLfloat normal[3];
	VECTOR_STRUCT_TYPE vertex[12];
	GLfloat t;

	poly_id=reserveDisplayListId(Name);

	if(poly_id==-1)
	{
		printf("\nNo more Display List ids available\n");
		return;
	}

	glNewList(poly_id,GL_COMPILE_AND_EXECUTE);

	setAmbientMaterialColor(0.0f,0.0f,0.5f,1.0f);
	setDiffuseMaterialColor(0.0f,0.0f,0.8f,1.0f);

	if(strcmp(Name,"Icoshedron")==0)
	{
	t=(float) sqrt((float)(5)-1)/2;

	/*Icoshedron*/
	vertex[0].m_x=0.0f;
	vertex[0].m_y=1.0f;
	vertex[0].m_z=t;

	vertex[1].m_x=0.0f;
	vertex[1].m_y=1.0f;
	vertex[1].m_z=-t;

	vertex[2].m_x=1.0f;
	vertex[2].m_y=t;
	vertex[2].m_z=0.0f;

	vertex[3].m_x=1.0f;
	vertex[3].m_y=-t;
	vertex[3].m_z=0.0f;

	vertex[4].m_x=0.0f;
	vertex[4].m_y=-1.0f;
	vertex[4].m_z=-t;

	vertex[5].m_x=0.0f;
	vertex[5].m_y=-1.0f;
	vertex[5].m_z=t;

	vertex[6].m_x=t;
	vertex[6].m_y=0.0f;
	vertex[6].m_z=1.0f;

	vertex[7].m_x=-t;
	vertex[7].m_y=0.0f;
	vertex[7].m_z=1.0f;

	vertex[8].m_x=t;
	vertex[8].m_y=0.0f;
	vertex[8].m_z=-1.0f;

	vertex[9].m_x=-t;
	vertex[9].m_y=0.0f;
	vertex[9].m_z=-1.0f;

	vertex[10].m_x=-1.0f;
	vertex[10].m_y=t;
	vertex[10].m_z=0.0f;

	vertex[11].m_x=-1.0f;
	vertex[11].m_y=-t;
	vertex[11].m_z=0.0f;



	/*Face 0 - 6,2,0*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[1],&vertex[2],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[6].m_x,vertex[6].m_y,vertex[6].m_z);
		glVertex3f(vertex[2].m_x,vertex[2].m_y,vertex[2].m_z);
		glVertex3f(vertex[0].m_x,vertex[0].m_y,vertex[0].m_z);
	glEnd();

	/*Face 1 - 2,6,3*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[3],&vertex[2],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[2].m_x,vertex[2].m_y,vertex[2].m_z);
		glVertex3f(vertex[6].m_x,vertex[6].m_y,vertex[6].m_z);
		glVertex3f(vertex[3].m_x,vertex[3].m_y,vertex[3].m_z);
	glEnd();

	/*Face 2 - 5,3,6*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[1],&vertex[3],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[5].m_x,vertex[5].m_y,vertex[5].m_z);
		glVertex3f(vertex[3].m_x,vertex[3].m_y,vertex[3].m_z);
		glVertex3f(vertex[6].m_x,vertex[6].m_y,vertex[6].m_z);
	glEnd();

	/*Face 3 - 5,6,7*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[5].m_x,vertex[5].m_y,vertex[5].m_z);
		glVertex3f(vertex[6].m_x,vertex[6].m_y,vertex[6].m_z);
		glVertex3f(vertex[7].m_x,vertex[7].m_y,vertex[7].m_z);
	glEnd();

	/*Face 4 - 0,7,6*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[0].m_x,vertex[0].m_y,vertex[0].m_z);
		glVertex3f(vertex[7].m_x,vertex[7].m_y,vertex[7].m_z);
		glVertex3f(vertex[6].m_x,vertex[6].m_y,vertex[6].m_z);
	glEnd();


	/*Face 5 - 3,8,2*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[3].m_x,vertex[3].m_y,vertex[3].m_z);
		glVertex3f(vertex[8].m_x,vertex[8].m_y,vertex[8].m_z);
		glVertex3f(vertex[2].m_x,vertex[2].m_y,vertex[2].m_z);
	glEnd();

	/*Face 6 - 2,8,1*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[2].m_x,vertex[2].m_y,vertex[2].m_z);
		glVertex3f(vertex[8].m_x,vertex[8].m_y,vertex[8].m_z);
		glVertex3f(vertex[1].m_x,vertex[1].m_y,vertex[1].m_z);
	glEnd();


	/*Face 7 - 1,0,2*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[1].m_x,vertex[1].m_y,vertex[1].m_z);
		glVertex3f(vertex[0].m_x,vertex[0].m_y,vertex[0].m_z);
		glVertex3f(vertex[2].m_x,vertex[2].m_y,vertex[2].m_z);
	glEnd();

	/*Face 8 - 0,1,10*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[0].m_x,vertex[0].m_y,vertex[0].m_z);
		glVertex3f(vertex[1].m_x,vertex[1].m_y,vertex[1].m_z);
		glVertex3f(vertex[10].m_x,vertex[10].m_y,vertex[10].m_z);
	glEnd();

		/*Face 9 - 9,10,1*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[9].m_x,vertex[9].m_y,vertex[9].m_z);
		glVertex3f(vertex[10].m_x,vertex[10].m_y,vertex[10].m_z);
		glVertex3f(vertex[1].m_x,vertex[1].m_y,vertex[1].m_z);
	glEnd();

		/*Face 10 - 9,1,8*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[9].m_x,vertex[9].m_y,vertex[9].m_z);
		glVertex3f(vertex[1].m_x,vertex[1].m_y,vertex[1].m_z);
		glVertex3f(vertex[8].m_x,vertex[8].m_y,vertex[8].m_z);
	glEnd();

		/*Face 11 - 8,3,4*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[8].m_x,vertex[8].m_y,vertex[8].m_z);
		glVertex3f(vertex[3].m_x,vertex[3].m_y,vertex[3].m_z);
		glVertex3f(vertex[4].m_x,vertex[4].m_y,vertex[4].m_z);
	glEnd();

		/*Face 12 - 3,5,4*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[3].m_x,vertex[3].m_y,vertex[3].m_z);
		glVertex3f(vertex[5].m_x,vertex[5].m_y,vertex[5].m_z);
		glVertex3f(vertex[4].m_x,vertex[4].m_y,vertex[4].m_z);
	glEnd();

			/*Face 13 - 4,5,11*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[4].m_x,vertex[4].m_y,vertex[4].m_z);
		glVertex3f(vertex[5].m_x,vertex[5].m_y,vertex[5].m_z);
		glVertex3f(vertex[11].m_x,vertex[11].m_y,vertex[11].m_z);
	glEnd();

			/*Face 14 - 7,10,11*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[7].m_x,vertex[7].m_y,vertex[7].m_z);
		glVertex3f(vertex[10].m_x,vertex[10].m_y,vertex[10].m_z);
		glVertex3f(vertex[11].m_x,vertex[11].m_y,vertex[11].m_z);
	glEnd();

	/*Face 15 - 10,7,0*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[10].m_x,vertex[10].m_y,vertex[10].m_z);
		glVertex3f(vertex[7].m_x,vertex[7].m_y,vertex[7].m_z);
		glVertex3f(vertex[0].m_x,vertex[0].m_y,vertex[0].m_z);
	glEnd();

	/*Face 16 - 11,9,4*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[11].m_x,vertex[11].m_y,vertex[11].m_z);
		glVertex3f(vertex[9].m_x,vertex[9].m_y,vertex[9].m_z);
		glVertex3f(vertex[4].m_x,vertex[4].m_y,vertex[4].m_z);
	glEnd();

	/*Face 17 - 8,4,9*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[8].m_x,vertex[8].m_y,vertex[8].m_z);
		glVertex3f(vertex[4].m_x,vertex[4].m_y,vertex[4].m_z);
		glVertex3f(vertex[9].m_x,vertex[9].m_y,vertex[9].m_z);
	glEnd();

	/*Face 18 - 7,11,5*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[7].m_x,vertex[7].m_y,vertex[7].m_z);
		glVertex3f(vertex[11].m_x,vertex[11].m_y,vertex[11].m_z);
		glVertex3f(vertex[5].m_x,vertex[5].m_y,vertex[5].m_z);
	glEnd();
	
	/*Face 19 - 10,9,11*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[10].m_x,vertex[10].m_y,vertex[10].m_z);
		glVertex3f(vertex[9].m_x,vertex[9].m_y,vertex[9].m_z);
		glVertex3f(vertex[11].m_x,vertex[11].m_y,vertex[11].m_z);
	glEnd();
	}
	else if(strcmp(Name,"Tetrahedron")==0)
	{
	/*Tetrahedron*/
	vertex[0].m_x=1.0f;
	vertex[0].m_y=1.0f;
	vertex[0].m_z=1.0f;

	vertex[1].m_x=1.0f;
	vertex[1].m_y=-1.0f;
	vertex[1].m_z=-1.0f;

	vertex[2].m_x=-1.0f;
	vertex[2].m_y=-1.0f;
	vertex[2].m_z=1.0f;

	vertex[3].m_x=-1.0f;
	vertex[3].m_y=1.0f;
	vertex[3].m_z=-1.0f;

	
	/*Face 0 - 1,2,3*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[1],&vertex[2],&vertex[3],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[1].m_x,vertex[1].m_y,vertex[1].m_z);
		glVertex3f(vertex[2].m_x,vertex[2].m_y,vertex[2].m_z);
		glVertex3f(vertex[3].m_x,vertex[3].m_y,vertex[3].m_z);
	glEnd();

	/*Face 1 - 0,3,2*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[3],&vertex[2],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[0].m_x,vertex[0].m_y,vertex[0].m_z);
		glVertex3f(vertex[3].m_x,vertex[3].m_y,vertex[3].m_z);
		glVertex3f(vertex[2].m_x,vertex[2].m_y,vertex[2].m_z);
	glEnd();

	/*Face 2 - 0,1,3*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[1],&vertex[3],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[0].m_x,vertex[0].m_y,vertex[0].m_z);
		glVertex3f(vertex[1].m_x,vertex[1].m_y,vertex[1].m_z);
		glVertex3f(vertex[3].m_x,vertex[3].m_y,vertex[3].m_z);
	glEnd();

	/*Face 3 - 0,2,1*/
	glBegin(GL_POLYGON);
		calcNormal(&vertex[0],&vertex[2],&vertex[1],normal);
		glNormal3f(normal[0],normal[1],normal[2]);
		glVertex3f(vertex[0].m_x,vertex[0].m_y,vertex[0].m_z);
		glVertex3f(vertex[2].m_x,vertex[2].m_y,vertex[2].m_z);
		glVertex3f(vertex[1].m_x,vertex[1].m_y,vertex[1].m_z);
	glEnd();

	}
	
	glEndList();
}
void Canvas::trefoilKnot(char *Name)
{
GLfloat x;
GLfloat y;
GLfloat z;
GLfloat phi;
GLfloat theta;
GLfloat v,u;
GLfloat r1;
GLfloat r2;
GLfloat Bx,By,Bz;
GLint id;
GLfloat vertexes[4][3];
GLfloat normal[3];
GLint patch_size;

	id=reserveDisplayListId(Name);

	if(id==-1)
	{
		printf("\nNo more Display List ids available\n");
		return;
	}

	glNewList(id,GL_COMPILE_AND_EXECUTE);

	patch_size=60;

	for(phi=0.0f; phi <= 360.0f; phi+=patch_size)
	{
	for(theta=0.0f; theta<=(360.0f*10.0f); theta+=patch_size)
	{
		v=(GLfloat)(phi/180.0f*3.142f);
		u=(GLfloat)(theta/180.0f*3.142f);
		
		r1 = 1.0f; 
		r2 = 3.0f; 

		/*Vertex 1*/
		 Bx = (GLfloat)(r2 + r1 * cos(u/2.0f) ) * cos(u/3.0f); 
		 By = (GLfloat)(r2 + r1 * cos(u/2.0f) ) * sin(u/3.0f); 
		 Bz = (GLfloat)r1 * sin(u/2.0f);

		 x = (GLfloat)Bx + r1 * cos(u/3.0f) * cos(v - 3.142f);
		 y = (GLfloat)By + r1 * sin(u/3.0f) * cos(v - 3.142f); 
		 z = (GLfloat)Bz + r1 * sin(v - 3.142f); 

		vertexes[0][0]=x;
		vertexes[0][1]=y;
		vertexes[0][2]=z;

		/*Vertex 2*/
		v=(GLfloat)(phi/180.0f*3.142f);
		u=(GLfloat)((theta+patch_size)/180.0f*3.142f);

		 Bx = (GLfloat)(r2 + r1 * cos(u/2.0f)) * cos(u/3.0f); 
		 By = (GLfloat)(r2 + r1 * cos(u/2.0f) ) * sin(u/3.0f); 
		 Bz = (GLfloat)r1 * sin(u/2.0f);

		 x = (GLfloat)(Bx + r1 * cos(u/3.0) * cos(v - 3.142f));
		 y = (GLfloat)(By + r1 * sin(u/3.0) * cos(v - 3.142f)); 
		 z = (GLfloat)(Bz + r1 * sin(v - 3.142f)); 

		vertexes[1][0]=x;
		vertexes[1][1]=y;
		vertexes[1][2]=z;

		/*Vertex 3*/
		v=(GLfloat)((phi+patch_size)/180.0f*3.142f);
		u=(GLfloat)((theta+patch_size)/180.0f*3.142f);

		 Bx = (GLfloat)((r2 + r1 * cos(u/2.0f)) * cos(u/3.0f)); 
		 By = (GLfloat)((r2 + r1 * cos(u/2.0f) ) * sin(u/3.0f)); 
		 Bz = (GLfloat)(r1 * sin(u/2.0f));

		 x = (GLfloat)(Bx + r1 * cos(u/3.0f) * cos(v - 3.142f));
		 y = (GLfloat)(By + r1 * sin(u/3.0f) * cos(v - 3.142f)); 
		 z = (GLfloat)(Bz + r1 * sin(v - 3.142f)); 

		vertexes[2][0]=x;
		vertexes[2][1]=y;
		vertexes[2][2]=z;

		/*Vertex 4*/
		v=(GLfloat)((phi+patch_size)/180.0*3.142f);
		u=(GLfloat)((theta)/180.0*3.142f);

		 Bx = (GLfloat)((r2 + r1 * cos(u/2.0f)) * cos(u/3.0f)); 
		 By = (GLfloat)((r2 + r1 * cos(u/2.0f) ) * sin(u/3.0f)); 
		 Bz = ((GLfloat)r1 * sin(u/2.0f));

		 x = (GLfloat)(Bx + r1 * cos(u/3.0f) * cos(v - 3.142f));
		 y = (GLfloat)(By + r1 * sin(u/3.0f) * cos(v - 3.142f)); 
		 z = (GLfloat)(Bz + r1 * sin(v - 3.142f)); 

		vertexes[3][0]=x;
		vertexes[3][1]=y;
		vertexes[3][2]=z;

		calcNormal2(vertexes,normal);
		glBegin(GL_POLYGON);
			glNormal3f(normal[0],normal[1],normal[2]);
			glVertex3f(vertexes[0][0],vertexes[0][1],vertexes[0][2]);
			glVertex3f(vertexes[1][0],vertexes[1][1],vertexes[1][2]);
			glVertex3f(vertexes[2][0],vertexes[2][1],vertexes[2][2]);
			glVertex3f(vertexes[3][0],vertexes[3][1],vertexes[3][2]);
		glEnd();
	}
	}

	glEndList();
}

void Canvas::traverseSceneGraph(treenode *root)
{
	if(root==NULL)
		return;
	//count++;
	//printf("PushMatrix %d\n",count);
	//printf("%s\n",root->node_key);
	glPushMatrix();
		//glMultMatrix(root->m);
		root->f();
		if (root->engine!=NULL)
		{
			root->engine();
		}
		if(root->child!=NULL)
		{
			traverseSceneGraph(root->child);
		}
	//count--;
	//printf("PopMatrix %d\n",count);

	glPopMatrix();
	
	if(root->sibling!=NULL)
			traverseSceneGraph(root->sibling);
}
treenode* Canvas::node(char *node_key)
{
	treenode *retNode;

	retNode=(treenode *) malloc (sizeof(treenode));
	retNode->child=NULL;
	retNode->sibling=NULL;
	retNode->engine=NULL;
	retNode->most_recent_child=NULL;
	strcpy(retNode->node_key,node_key);

	return(retNode);

}
void Canvas::addChild(treenode *parentNode, treenode *childNode)
{
	/*
	Observations
	1) addChild rules:
	a) A parent has only one child
	b) If another child is associated to the parent it becomes a sibling of the parents first child.  That child becomes the parent's most_recent_child.  Any additional children are associated to the parent's most_recent_child sibling link.
	c) The parents first child sibling link is traverse to find all remaining children.  This is the key for the algorithm to work correctly.
	*/

	treenode *most_recent_child;
	//walk down the tree from the topmost child
	//connect the sibling link from the most recent child
	most_recent_child=parentNode->most_recent_child;
	
	strcpy(childNode->parent_key,parentNode->node_key);

	if (most_recent_child!=NULL)
	{
		most_recent_child->sibling=childNode;
		parentNode->most_recent_child=childNode;
	}
	//first child
	else
	{
		parentNode->child=childNode;
		parentNode->most_recent_child=childNode;
	}
	errorHandler("Scene Graph Add Child");

}
void Canvas::cleanSceneGraph(treenode *root)
{
	if(root->child!=NULL)
		cleanSceneGraph(root->child);
	
	if(root->sibling!=NULL)
		cleanSceneGraph(root->sibling);

	free(root);
}
int Canvas::getAvailableBall()
{
	int i;
	for(i=0; i<NUMBER_OF_BALLS; i++)
	{
		if (objBall[i].m_available_flag==TRUE)
			return(i);
	}
	return(-1);
}
void Canvas::launchBall(GLint Yaw,GLint Pitch,GLfloat Vo)
{
	GLfloat x;
	GLfloat y;
	GLfloat z;
	GLfloat Vox;
	GLfloat Voy;
	GLfloat Xo;
	GLfloat Yo;
	GLint i;
	GLfloat t=0.0f;

	i=getAvailableBall();

	if(i>-1)
	{
		//x(t)=Xo + Vox*t
		//y(t)=Yo + Voy*t - 1/2*g*t*t
		objBall[i].m_pitch=Pitch;
		objBall[i].m_Vo=Vo;

		Xo=objBall[i].m_Xo;
		Yo=objBall[i].m_Yo;

		Vox=(GLfloat)(Vo*cos(Pitch/180.0*3.142f));
		Voy=(GLfloat)(Vo*sin(Pitch/180.0*3.142f));

		x=Xo+Vox*t;
		y=Yo+Voy*t - 0.5f*32.0f*t*t;
		z=0.0f;
		
		objBall[i].m_x=x;
		objBall[i].m_y=y;
		objBall[i].m_z=z;
		objBall[i].m_Vo=Vo;
		objBall[i].m_Vox=Vox;
		objBall[i].m_Voy=Voy;
		objBall[i].m_yaw=Yaw;
		objBall[i].m_pitch=(GLint)Pitch;
		objBall[i].m_available_flag=(GLfloat)FALSE;
		objBall[i].active_flag=(GLfloat)TRUE;
	}
}
VECTOR_STRUCT_TYPE* Canvas::getRandomPosition()
{
	VECTOR_STRUCT_TYPE* v;
	GLfloat x,y,z;
	x=(GLfloat)(rand()%500)-250;
	y=10.0f;
	z=(GLfloat)(rand()%500)-250;
	
	v= (VECTOR_STRUCT_TYPE *) malloc (sizeof(VECTOR_STRUCT_TYPE));
	v->m_x=x;
	v->m_y=y;
	v->m_z=z;
	return(v);
}
void Canvas::buildObjectList(char *Name)
{
	int i;
	VECTOR_STRUCT_TYPE* v;

	for(i=0; i<OBJECT_LIST_SIZE; i++)
	{
		objList[i].m_id=findDisplayListId(Name);
		v=getRandomPosition();
		objList[i].m_x=v->m_x;
		objList[i].m_y=v->m_y;
		objList[i].m_z=v->m_z;
		objList[i].m_available_flag=(GLfloat) TRUE;
		free(v);
	}
}
void Canvas::drawObjectList()
{
	int i;

		setSpecularMaterialColor(1.0f,1.0f,1.0f,0.6f);
		setMaterialShininess(128.0f);
		setDiffuseMaterialColor(0.8f,0.0f,0.0f,0.6f);
		setAmbientMaterialColor(0.2f,0.0f,0.0f,0.6f);

		for(i=0; i<OBJECT_LIST_SIZE; i++)
		{
			if(objList[i].m_available_flag==TRUE)
			{
			glPushMatrix();
				glTranslatef(objList[i].m_x,objList[i].m_y,objList[i].m_z);
				glScalef(4.0f,4.0f,4.0f);
				glCallList(findDisplayListId("Torus"));
			glPopMatrix();
			}
		}

}

void Canvas::empty()
{
}

void Canvas::buildMissile()
{
	GLint id;

	id=reserveDisplayListId("Missile");

	if(id==-1)
	{
		printf("\nNo more Display List ids available\n");
		return;
	}

	glNewList(id,GL_COMPILE_AND_EXECUTE);


	glPushMatrix();
		glRotatef(180.0f,0.0f,1.0f,0.0f);
		glRotatef(90.0f,0.0f,0.0f,1.0f);
		glPushMatrix();
			glPushMatrix();
				glTranslatef(0.0f,3.0f,0.0f);
				cone(1.5f,3.0f);
			glPopMatrix();

			cylinder(1.5f,10.0f);

			glPushMatrix();
				glTranslatef(0.0f,-5.0f,0.0f);
				glBegin(GL_POLYGON);
					glNormal3f(0.0f,1.0f,0.0f);
					glVertex3f(0.0f,0.0f,0.0f);
					glVertex3f(0.0f,-5.0f,0.0f);
					glVertex3f(-3.6f,-5.0f,0.0f);
					glVertex3f(-3.5f,-5.0f,0.0f);
				glEnd();

				glBegin(GL_POLYGON);
					glNormal3f(0.0f,1.0f,0.0f);
					glVertex3f(0.0f,0.0f,0.0f);
					glVertex3f(5.1f,-5.0f,0.0f);
					glVertex3f(5.0f,-5.0f,0.0f);
					glVertex3f(0.0f,-3.0f,0.0f);
				glEnd();
				
				glBegin(GL_POLYGON);
					glNormal3f(0.0f,1.0f,0.0f);
					glVertex3f(0.0f,0.0f,0.0f);
					glVertex3f(0.0f,-5.0f,0.0f);
					glVertex3f(5.0f,-5.0f,3.0f);
					glVertex3f(0.0f,-5.0f,0.0f);
				glEnd();

				glBegin(GL_POLYGON);
					glNormal3f(0.0f,1.0f,0.0f);
					glVertex3f(0.0f,0.0f,0.0f);
					glVertex3f(0.0f,-5.0f,0.0f);
					glVertex3f(5.0f,-5.0f,-3.0f);
					glVertex3f(0.0f,-5.0f,0.0f);
				glEnd();

			glPopMatrix();

		glPopMatrix();
	glPopMatrix();
	glEndList();
}
/*
int Canvas::getAvailableExplosion()
{
	int i;
	for(i=0; i<EXPLOSION_SIZE; i++)
	{
		if (objExplosion[i].available_flag==TRUE)
			objExplosion[i].active_flag=TRUE;
			objExplosion[i].available_flag=FALSE;
			return(i);
	}
	return(-1);

}
void Canvas::drawExplosion()
{
	int i;

	for(i=0; i<EXPLOSION_SIZE; i++)
	{
		if(objExplosion[i].active_flag==TRUE)
		{
			if((clock()-objExplosion[i].m_cpu_seconds)>1000)
			{
				objExplosion[i].available_flag=TRUE;
				objExplosion[i].active_flag=FALSE;
				objExplosion[i].scale_x=2.0f;
				objExplosion[i].scale_y=2.0f;
				objExplosion[i].scale_z=2.0f;
				break;
			}
			glPushMatrix();
				glTranslatef(objExplosion[i].x,objExplosion[i].y,objExplosion[i].z);
				glScalef(objExplosion[i].scale_x,objExplosion[i].scale_y,objExplosion[i].scale_z);
				objExplosion[i].scale_x+=1.0f;
				objExplosion[i].scale_y+=1.0f;
				objExplosion[i].scale_z+=1.0f;
				glRotatef(90.0f,1.0f,0.0f,0.0f);
				goldMaterial();
				glCallList(findDisplayListId("Torus"));
			glPopMatrix();
		}
		
	}
}
*/