#ifdef WIN32
#include "windows.h"
#endif

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <string.h>

#include "canvas.h"
#include "fractal.h"

TURTLE_STRUCT_TYPE* addTurtleCommand(char command)
{
	TURTLE_STRUCT_TYPE *current;
	current=(TURTLE_STRUCT_TYPE *) malloc (sizeof(TURTLE_STRUCT_TYPE));
	current->command[0]=command;
	return(current);
}
void branch_generation(int interation)
{
	TURTLE_STRUCT_TYPE *current,*next;
	/*
	Replace every F with FF-[-F+F+F]+[+F-F-F]
	*/

	if(interation==0)
	{
		return;
	}
	current=cvs.turtle_head;

	while(current != NULL)
	{
		if(current->command[0]=='F')
		{
			next=current->next;

			current->next=addTurtleCommand('F');
			current=current->next;
			current->next=addTurtleCommand('-');
			current=current->next;
			current->next=addTurtleCommand('[');
			current=current->next;
			current->next=addTurtleCommand('-');
			current=current->next;
			current->next=addTurtleCommand('F');
			current=current->next;
			current->next=addTurtleCommand('+');
			current=current->next;
			current->next=addTurtleCommand('F');
			current=current->next;
			current->next=addTurtleCommand('+');
			current=current->next;
			current->next=addTurtleCommand('F');
			current=current->next;
			current->next=addTurtleCommand(']');
			current=current->next;
			current->next=addTurtleCommand('+');
			current=current->next;
			current->next=addTurtleCommand('[');
			current=current->next;
			current->next=addTurtleCommand('+');
			current=current->next;
			current->next=addTurtleCommand('F');
			current=current->next;
			current->next=addTurtleCommand('-');
			current=current->next;
			current->next=addTurtleCommand('F');
			current=current->next;
			current->next=addTurtleCommand('-');
			current=current->next;
			current->next=addTurtleCommand('F');
			current=current->next;
			current->next=addTurtleCommand(']');
			current=current->next;
			current->next=next;
		}
		current=current->next;
	}
	branch_generation(interation-1);
}
void buildBranchFractal()
{
	TURTLE_STRUCT_TYPE *current;
	//branch fractal

	cvs.turtle_head=addTurtleCommand('F');
	current=cvs.turtle_head;
	current->next=NULL;

	branch_generation(4);
}
void drawBranchFractal()
{
	TURTLE_STRUCT_TYPE *current;
	POINT_LIST_STRUCT_TYPE *stack_head,*stack_tail,*temp;

	setSpecularMaterialColor(1,1,1,1);
	setMaterialShininess(128);
	setDiffuseMaterialColor(.8,0,0,1);
	setAmbientMaterialColor(.2,0,0,1);

	glPushMatrix();
		glTranslatef(-30,60,0);
		glRotatef(90,1,0,0);
		glCallList(findDisplayListId("Helix"));
	glPopMatrix();

	current=cvs.turtle_head;

	moveTo(40,-60);
	setTurn(90);
	glPushMatrix();

	stack_head=NULL;
	stack_tail=NULL;

	while (current!=NULL)
	{

		if (current->command[0]=='F')
		{
			forward(2,TRUE);
		}
		else if (current->command[0]=='[')
		{
			if(stack_tail==NULL)
			{
				stack_tail=(POINT_LIST_STRUCT_TYPE*) malloc (sizeof(POINT_LIST_STRUCT_TYPE));
				stack_head=stack_tail;
				stack_head->next=NULL;
				stack_tail->next=NULL;
				stack_head->previous=NULL;
				stack_tail->previous=NULL;
			}
			else
			{
				temp=(POINT_LIST_STRUCT_TYPE*) malloc (sizeof(POINT_LIST_STRUCT_TYPE));
				temp->next=stack_head;
				stack_head=temp;
			}
			stack_head->x=cvs.CP.x;
			stack_head->y=cvs.CP.y;
			//stack_tail->angle=cvs.m_CurrDegree-90;
		
		}
		else if (current->command[0]==']')
		{
			if(stack_tail != NULL)
			{
				moveTo(stack_head->x,stack_head->y);
				//cvs.moveTo(stack_tail->x,stack_tail->y);
				//cvs.turn(stack_head->angle);				
				turn(0);
				temp=stack_head;
				//stack_tail=stack_tail->previous;
				stack_head=stack_head->next;
				free(temp);
			}
			if(stack_head==NULL)
			{
				stack_tail=NULL;
			}
			glPointSize(5);
			glBegin(GL_POINTS);
				glVertex2d(cvs.CP.x,cvs.CP.y);
			glEnd();
		}
		else if (current->command[0]=='-')
		{
			turn(-20);
		}
		else if (current->command[0]=='+')
		{
			turn(20);
		}

		current=current->next;
	}
}

void processBranchFractal()
{
	drawBranchFractal();
}
void generation(int interation)
{
	TURTLE_STRUCT_TYPE *current, *next;
	/*Replace every F with F
	X with X+YF+
	Y with FX-Y
	Dragon
	*/

	if(interation==0)
	{
		return;
	}
	current=cvs.turtle_head;

	while(current != NULL)
	{
		if(current->command[0]=='X')
		{
			next=current->next;

			current->next=addTurtleCommand('+');
			current=current->next;
			current->next=addTurtleCommand('Y');
			current=current->next;
			current->next=addTurtleCommand('F');
			current=current->next;
			current->next=addTurtleCommand('+');
			current=current->next;
			current->next=next;
		}
		else if(current->command[0]=='Y')
		{
			next=current->next;

			current->command[0]='-';
			current->next=addTurtleCommand('F');
			current=current->next;
			current->next=addTurtleCommand('X');
			current=current->next;
			current->next=addTurtleCommand('-');
			current=current->next;
			current->next=addTurtleCommand('Y');
			current=current->next;
			current->next=next;
		}
		current=current->next;
	}
	generation(interation-1);
}
void buildFractal()
{
	/*Dragon*/
	TURTLE_STRUCT_TYPE *current;

	cvs.turtle_head=addTurtleCommand('F');
	current=cvs.turtle_head;
	current->next=addTurtleCommand('X');
	current=current->next;
	current->next=addTurtleCommand('+');
	current=current->next;
	current->next=addTurtleCommand('Y');
	current=current->next;
	current->next=addTurtleCommand('F');
	current=current->next;
	current->next=addTurtleCommand('+');
	current=current->next;
	current->next=NULL;

	generation(12);

}
void drawFractal()
{
	TURTLE_STRUCT_TYPE *current;

	current=cvs.turtle_head;

	moveTo(40,0);
	setTurn(0);
	glPushMatrix();

	while (current!=NULL)
	{
		if (current->command[0]=='F')
		{
			forward(1,TRUE);
		}
		else if (current->command[0]=='-')
		{
			turn(-90);
		}
		else if (current->command[0]=='+')
		{
			turn(90);
		}

		current=current->next;
	}
}
void processFractal()
{
	drawFractal();
}
