#ifdef WIN32
#include "windows.h"
#endif

#include <GL/gl.h>
#include <GL/glu.h>
#include <GL/glut.h>
#include <math.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include <string.h>

#include "spline.h"

void bSpline()
{
GLUnurbsObj *pNurb=NULL;
float crtPoints[8][3]={
	{4.0,-6.0,6.0},
	{-4.0,1.0,0.0},
	{-1.5,5.0,-6.0},
	{0.0,2.0,-2.0},
	{1.5,5.0,-6.0},
	{4.0,1.0,0.0},
	{-4.0,-6.0,6.0}
};
float knots[10]={1,2,3,4,5,5,6,7,8,9}; //Uniform cubic B-spline

	pNurb=gluNewNurbsRenderer();

	//gluNurbsProperty(pNurb,GLU_PARAMETRIC_TOLERANCE,0.01);
	gluNurbsProperty(pNurb,GLU_SAMPLING_TOLERANCE,25);

	gluBeginCurve(pNurb);
	gluNurbsCurve(pNurb,
		10,knots,
		3,
		&crtPoints[0][0],
		3,
		GL_MAP1_VERTEX_3);
	gluEndCurve(pNurb);
	
	gluDeleteNurbsRenderer(pNurb);
}
void bSplineSceneGraph()
{
	cvs.root=node("root");
	cvs.root->f=bSpline;
}
void processBSpline()
{
	glScalef(10.0,10.0,10.0);
	glPushAttrib(GL_LIGHTING);
	glDisable(GL_LIGHTING);
	glRGB(255,0,0);
	traverseSceneGraph(cvs.root);
	glPopAttrib();

}
